/**  
  * Binrt tr uden speciel node-klasse
  * 
  * @version  Februar 2003 (2.0)
  * @author   Bjrk Busch
*/  

public  class  BinTree
{
  protected  BinTree     left = null;
  protected  BinTree     right = null;
  protected  Comparable  data = null;  // null hvis tom tr

  public BinTree ()                    // constructor
  {}

  public BinTree newBinTree()          // ndvendig for specialisering ved nedarvning
  { return new BinTree(); }            // skal overwrites i specialisering

  public  void  insert (Comparable  data)
  {
    if (this.data == null)       // tree er tomt men tree-objekt findes
      this.data = data;
    else if (data.compareTo(this.data) <= 0)
    {
      if (this.left  == null) this.left = newBinTree ();
      this.left.insert (data);  // indst i venstre tree
    }
    else
    {
      if (this.right == null) this.right = newBinTree ();
      this.right.insert (data); // indst i hjre tree
    }
  }

  public  boolean  contains (Comparable  data)
  {
    return findTree(data) != null; 
  }
    
  public  BinTree  findTree (Comparable  data)  // returner tr, hvor data er i "root"
  {
    if (this.data == null) return null;        // Tomt tree

    if (data.compareTo(this.data) < 0)          // er den mindre
    {
      if (this.left == null) return null;      // Tomt/ingen tree
      return this.left.findTree(data);          //    skal vi til venstre
    }
    else if (data.compareTo(this.data) > 0)     // er den strre
    {
      if (this.right == null) return null;     // Tomt/ingen tree
      return this.left.findTree(data);          //    skal vi til hjre    
    }
    else if (data != this.data)                 // samme vrdi men ikke samme objekt
    {
      if (this.left == null) return null;      // Tomt/ingen tree
      return this.left.findTree(data);          //    skal vi til venstre
    }                                           // hvis kun krav til samme vrdi
                                                // skal tree returneres istedet
    else return this;                           // samme objekt
  }


} // slut class  BinTree