/**  
  * Binrt tr  udvidet med traversering der anvender TreeActionListener
  * uden speciel node-klasse
  * 
  * @version  Februar 2003 (2.0)
  * @author   Bjrk Busch
*/  

public  class  BinTreeDerBrugerActionListener extends BinTree
{

  public BinTree newBinTree()                      // nyt specialiserings objekt
  { return new BinTreeDerBrugerActionListener(); } // skal overwrites i specialisering


  public  void  traversInOrder(TreeActionListener act)
  {
    if (this.data != null)
      this.traversTreeInOrder(act, 0);
  }
  
  public  void  traversTreeInOrder(TreeActionListener act, int level)
  {
    if (this.left  != null) 
      ((BinTreeDerBrugerActionListener)this.left).traversTreeInOrder(act, level+1);
    act.treeAction (this.data,level);     
    if (this.right != null) 
      ((BinTreeDerBrugerActionListener)this.right).traversTreeInOrder(act, level+1);     
  }


  public  void  traversPreOrder(TreeActionListener act)
  {
    if (this.data != null)
      this.traversTreePreOrder(act, 0);
  }
  public  void  traversTreePreOrder(TreeActionListener act, int level)
  {
    act.treeAction (this.data,level);     
    if (this.left  != null) 
      ((BinTreeDerBrugerActionListener)this.left).traversTreePreOrder(act, level+1);
    if (this.right != null) 
      ((BinTreeDerBrugerActionListener)this.right).traversTreePreOrder(act, level+1);     
  }


  public  void  traversPostOrder(TreeActionListener act)
  {
    if (this.data != null)
      this.traversTreePostOrder(act, 0);
  }
  public  void  traversTreePostOrder(TreeActionListener act, int level)
  {
    if (this.left  != null)
      ((BinTreeDerBrugerActionListener)this.left).traversTreePostOrder(act, level+1);
    if (this.right != null)
      ((BinTreeDerBrugerActionListener)this.right).traversTreePostOrder(act, level+1);     
    act.treeAction (this.data,level);     
  }

} // slut class  BinTreeDerBrugerActionListener