import javabook.Format;
/**  
  * Binrt tr  udvidet med traversering der udskriver
  * uden speciel node-klasse
  * 
  * @version  Februar 2003 (2.0)
  * @author   Bjrk Busch
*/  

public  class  BinTreeMedUdskriftTraversering extends BinTree
{
  public BinTree newBinTree()                      // nyt specialiserings objekt
  { return new BinTreeMedUdskriftTraversering(); } // skal overwrites i specialisering

  public void udskrivData (Object object, int level)
  {
    String levelTxt = Format.leftAlign(level*3+4,""+level+":");
    System.out.println ( levelTxt + object.toString() );
  }

  public  void  traversInOrder()
  {
    if (this.data != null)
      this.traversTreeInOrder(0);
  }
  
  public  void  traversTreeInOrder(int level)
  {
    if (this.left  != null)
      ((BinTreeMedUdskriftTraversering)this.left).traversTreeInOrder(level+1);
    this.udskrivData (this.data,level);     
    if (this.right != null)
      ((BinTreeMedUdskriftTraversering)this.right).traversTreeInOrder(level+1);     
  }


  public  void  traversPreOrder()
  {
    if (this.data != null)
      this.traversTreePreOrder(0);
  }
  public  void  traversTreePreOrder(int level)
  {
    this.udskrivData (this.data,level);     
    if (this.left  != null)
      ((BinTreeMedUdskriftTraversering)this.left).traversTreePreOrder(level+1);
    if (this.right != null) 
      ((BinTreeMedUdskriftTraversering)this.right).traversTreePreOrder(level+1);     
  }


  public  void  traversPostOrder()
  {
    if (this.data != null)
      this.traversTreePostOrder(0);
  }
  public  void  traversTreePostOrder(int level)
  {
    if (this.left  != null) 
      ((BinTreeMedUdskriftTraversering)this.left).traversTreePostOrder(level+1);
    if (this.right != null) 
      ((BinTreeMedUdskriftTraversering)this.right).traversTreePostOrder(level+1);     
    this.udskrivData (this.data,level);     
  }
} // slut class  BinTreeMedUdskriftTraversering